---
title: App Model
weight: 4220
---

# Flogo Application Model

The *flogo.json* file is the metadata describing an application. The application dictates the dependencies to be used during compile time and can also be embeded into the compiled binary.

```json
{
  "name": "myApp",
  "type": "flogo:app",
  "version": "0.0.1",
  "description": "My flogo application description",
  "triggers": [
    {
      "id": "my_rest_trigger",
      "ref": "github.com/TIBCOSoftware/flogo-contrib/trigger/rest",
      "settings": {
        "port": "9233"
      },
      "handlers": [
        {
          "actionId": "my_simple_flow",
          "settings": {
            "method": "GET",
            "path": "/test"
          }
        }
      ]
    }
  ],
  "actions": [
    {
      "id": "my_simple_flow",
      "ref": "github.com/TIBCOSoftware/flogo-contrib/action/flow",
      "data": {
        "flow": {
          "attributes": [],
          "rootTask": {
            "id": 1,
            "type": 1,
            "tasks": [
              {
                "id": 2,
                "type": 1,
                "activityRef": "github.com/TIBCOSoftware/flogo-contrib/activity/log",
                "name": "log",
                "attributes": [
                  {
                    "name": "message",
                    "value": "Simple Log",
                    "type": "string"
                  }
                ]
              }
            ],
            "links": [
            ]
          }
        }
      }
    }
  ]
}
```

## Root Properties

- name: The application name
- type: The type of application. Currently the only valid value is `flogo:app`

## Triggers

- id: the ID of the trigger
- settings: global settings for the trigger
- *handlers* the handlers for endpoints configured for the trigger
	- actionId: the ID of the action the handler invokes
	- settings: the handler specific settings